/* Process.c generated by valac 0.42.6, the Vala compiler
 * generated from Process.vala, do not modify */

/* Process.vala
 *
 * Copyright 2019 Hannes Schulze
 *
 * Simplified version of Process.vala by stsdc published under
 * the GPL-3.0 license:
 * https://github.com/stsdc/monitor/blob/master/src/Managers/Process.vala
 *
 * This program is free software: you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation, either version 3 of the License, or
 * (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program.  If not, see <http://www.gnu.org/licenses/>.
 */


#include <glib.h>
#include <glib-object.h>
#include <stdlib.h>
#include <string.h>
#include <float.h>
#include <math.h>
#include <signal.h>
#include <sys/types.h>
#include <gio/gio.h>
#include <stdio.h>
#include <glibtop/procuid.h>
#include <glibtop.h>
#include <glibtop/proctime.h>
#include <glibtop/procmem.h>
#include <gdk/gdk.h>
#include <gdk/gdkx.h>
#include <libwnck/libwnck.h>
#include <unistd.h>
#include <glibtop/procstate.h>
#include <gobject/gvaluecollector.h>


#define OPTIMIZER_UTILS_TYPE_PROCESS (optimizer_utils_process_get_type ())
#define OPTIMIZER_UTILS_PROCESS(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), OPTIMIZER_UTILS_TYPE_PROCESS, OptimizerUtilsProcess))
#define OPTIMIZER_UTILS_PROCESS_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), OPTIMIZER_UTILS_TYPE_PROCESS, OptimizerUtilsProcessClass))
#define OPTIMIZER_UTILS_IS_PROCESS(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), OPTIMIZER_UTILS_TYPE_PROCESS))
#define OPTIMIZER_UTILS_IS_PROCESS_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), OPTIMIZER_UTILS_TYPE_PROCESS))
#define OPTIMIZER_UTILS_PROCESS_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), OPTIMIZER_UTILS_TYPE_PROCESS, OptimizerUtilsProcessClass))

typedef struct _OptimizerUtilsProcess OptimizerUtilsProcess;
typedef struct _OptimizerUtilsProcessClass OptimizerUtilsProcessClass;
typedef struct _OptimizerUtilsProcessPrivate OptimizerUtilsProcessPrivate;
#define _g_free0(var) (var = (g_free (var), NULL))
#define _g_object_unref0(var) ((var == NULL) ? NULL : (var = (g_object_unref (var), NULL)))
#define _g_error_free0(var) ((var == NULL) ? NULL : (var = (g_error_free (var), NULL)))
typedef struct _OptimizerUtilsParamSpecProcess OptimizerUtilsParamSpecProcess;

struct _OptimizerUtilsProcess {
	GTypeInstance parent_instance;
	volatile int ref_count;
	OptimizerUtilsProcessPrivate * priv;
};

struct _OptimizerUtilsProcessClass {
	GTypeClass parent_class;
	void (*finalize) (OptimizerUtilsProcess *self);
};

struct _OptimizerUtilsProcessPrivate {
	gboolean _exists;
	gint _pid;
	gint _pgrp;
	gchar* _command;
	gchar* _user;
	gdouble _cpu_usage;
	guint64 cpu_last_used;
	guint64 _mem_usage;
	guint64 last_total;
};

struct _OptimizerUtilsParamSpecProcess {
	GParamSpec parent_instance;
};


static gint OptimizerUtilsProcess_private_offset;
static gpointer optimizer_utils_process_parent_class = NULL;

gpointer optimizer_utils_process_ref (gpointer instance);
void optimizer_utils_process_unref (gpointer instance);
GParamSpec* optimizer_utils_param_spec_process (const gchar* name,
                                                const gchar* nick,
                                                const gchar* blurb,
                                                GType object_type,
                                                GParamFlags flags);
void optimizer_utils_value_set_process (GValue* value,
                                        gpointer v_object);
void optimizer_utils_value_take_process (GValue* value,
                                         gpointer v_object);
gpointer optimizer_utils_value_get_process (const GValue* value);
GType optimizer_utils_process_get_type (void) G_GNUC_CONST;
OptimizerUtilsProcess* optimizer_utils_process_new (gint _pid);
OptimizerUtilsProcess* optimizer_utils_process_construct (GType object_type,
                                                          gint _pid);
static void optimizer_utils_process_set_pid (OptimizerUtilsProcess* self,
                                      gint value);
static gboolean optimizer_utils_process_read_stat (OptimizerUtilsProcess* self,
                                            guint64 cpu_total,
                                            guint64 cpu_last_total);
static gboolean optimizer_utils_process_read_cmdline (OptimizerUtilsProcess* self);
static void optimizer_utils_process_set_exists (OptimizerUtilsProcess* self,
                                         gboolean value);
gboolean optimizer_utils_process_update (OptimizerUtilsProcess* self,
                                         guint64 cpu_total,
                                         guint64 cpu_last_total);
gboolean optimizer_utils_process_get_exists (OptimizerUtilsProcess* self);
gboolean optimizer_utils_process_kill (OptimizerUtilsProcess* self);
gint optimizer_utils_process_get_pid (OptimizerUtilsProcess* self);
static void optimizer_utils_process_set_pgrp (OptimizerUtilsProcess* self,
                                       gint value);
static void optimizer_utils_process_set_cpu_usage (OptimizerUtilsProcess* self,
                                            gdouble value);
static void optimizer_utils_process_set_mem_usage (OptimizerUtilsProcess* self,
                                            guint64 value);
guint64 optimizer_utils_process_get_mem_usage (OptimizerUtilsProcess* self);
static void optimizer_utils_process_set_user (OptimizerUtilsProcess* self,
                                       const gchar* value);
static void optimizer_utils_process_set_command (OptimizerUtilsProcess* self,
                                          const gchar* value);
gint optimizer_utils_process_get_pgrp (OptimizerUtilsProcess* self);
const gchar* optimizer_utils_process_get_command (OptimizerUtilsProcess* self);
const gchar* optimizer_utils_process_get_user (OptimizerUtilsProcess* self);
gdouble optimizer_utils_process_get_cpu_usage (OptimizerUtilsProcess* self);
static void optimizer_utils_process_finalize (OptimizerUtilsProcess * obj);


static inline gpointer
optimizer_utils_process_get_instance_private (OptimizerUtilsProcess* self)
{
	return G_STRUCT_MEMBER_P (self, OptimizerUtilsProcess_private_offset);
}


OptimizerUtilsProcess*
optimizer_utils_process_construct (GType object_type,
                                   gint _pid)
{
	OptimizerUtilsProcess* self = NULL;
	gboolean _tmp0_ = FALSE;
#line 63 "../src/utils/Process.vala"
	self = (OptimizerUtilsProcess*) g_type_create_instance (object_type);
#line 64 "../src/utils/Process.vala"
	optimizer_utils_process_set_pid (self, _pid);
#line 65 "../src/utils/Process.vala"
	self->priv->last_total = (guint64) 0;
#line 67 "../src/utils/Process.vala"
	if (optimizer_utils_process_read_stat (self, (guint64) 0, (guint64) 1)) {
#line 67 "../src/utils/Process.vala"
		_tmp0_ = optimizer_utils_process_read_cmdline (self);
#line 167 "Process.c"
	} else {
#line 67 "../src/utils/Process.vala"
		_tmp0_ = FALSE;
#line 171 "Process.c"
	}
#line 67 "../src/utils/Process.vala"
	optimizer_utils_process_set_exists (self, _tmp0_);
#line 63 "../src/utils/Process.vala"
	return self;
#line 177 "Process.c"
}


OptimizerUtilsProcess*
optimizer_utils_process_new (gint _pid)
{
#line 63 "../src/utils/Process.vala"
	return optimizer_utils_process_construct (OPTIMIZER_UTILS_TYPE_PROCESS, _pid);
#line 186 "Process.c"
}


gboolean
optimizer_utils_process_update (OptimizerUtilsProcess* self,
                                guint64 cpu_total,
                                guint64 cpu_last_total)
{
	gboolean result = FALSE;
	gboolean _tmp0_;
#line 72 "../src/utils/Process.vala"
	g_return_val_if_fail (self != NULL, FALSE);
#line 73 "../src/utils/Process.vala"
	optimizer_utils_process_set_exists (self, optimizer_utils_process_read_stat (self, cpu_total, cpu_last_total));
#line 75 "../src/utils/Process.vala"
	_tmp0_ = self->priv->_exists;
#line 75 "../src/utils/Process.vala"
	result = _tmp0_;
#line 75 "../src/utils/Process.vala"
	return result;
#line 207 "Process.c"
}


gboolean
optimizer_utils_process_kill (OptimizerUtilsProcess* self)
{
	gboolean result = FALSE;
	gint _tmp0_;
#line 80 "../src/utils/Process.vala"
	g_return_val_if_fail (self != NULL, FALSE);
#line 81 "../src/utils/Process.vala"
	_tmp0_ = self->priv->_pid;
#line 81 "../src/utils/Process.vala"
	if (kill ((pid_t) _tmp0_, (gint) SIGINT) == 0) {
#line 82 "../src/utils/Process.vala"
		result = TRUE;
#line 82 "../src/utils/Process.vala"
		return result;
#line 226 "Process.c"
	}
#line 84 "../src/utils/Process.vala"
	result = FALSE;
#line 84 "../src/utils/Process.vala"
	return result;
#line 232 "Process.c"
}


static gboolean
optimizer_utils_process_read_stat (OptimizerUtilsProcess* self,
                                   guint64 cpu_total,
                                   guint64 cpu_last_total)
{
	gboolean result = FALSE;
	GFile* stat_file = NULL;
	gint _tmp0_;
	gchar* _tmp1_;
	gchar* _tmp2_;
	GFile* _tmp3_;
	GFile* _tmp4_;
	GFile* _tmp5_;
	GError* _inner_error0_ = NULL;
#line 88 "../src/utils/Process.vala"
	g_return_val_if_fail (self != NULL, FALSE);
#line 90 "../src/utils/Process.vala"
	_tmp0_ = self->priv->_pid;
#line 90 "../src/utils/Process.vala"
	_tmp1_ = g_strdup_printf ("/proc/%d/stat", _tmp0_);
#line 90 "../src/utils/Process.vala"
	_tmp2_ = _tmp1_;
#line 90 "../src/utils/Process.vala"
	_tmp3_ = g_file_new_for_path (_tmp2_);
#line 90 "../src/utils/Process.vala"
	_tmp4_ = _tmp3_;
#line 90 "../src/utils/Process.vala"
	_g_free0 (_tmp2_);
#line 90 "../src/utils/Process.vala"
	stat_file = _tmp4_;
#line 93 "../src/utils/Process.vala"
	_tmp5_ = stat_file;
#line 93 "../src/utils/Process.vala"
	if (!g_file_query_exists (_tmp5_, NULL)) {
#line 94 "../src/utils/Process.vala"
		result = FALSE;
#line 94 "../src/utils/Process.vala"
		_g_object_unref0 (stat_file);
#line 94 "../src/utils/Process.vala"
		return result;
#line 276 "Process.c"
	}
	{
		GFileInputStream* _tmp6_ = NULL;
		GFile* _tmp7_;
		GFileInputStream* _tmp8_;
		GDataInputStream* dis = NULL;
		GDataInputStream* _tmp9_;
		gchar* stat_contents = NULL;
		GDataInputStream* _tmp10_;
		gchar* _tmp11_;
		const gchar* _tmp12_;
		glibtop_proc_uid uid = {0};
		gint _tmp17_;
		glibtop_proc_uid _tmp18_ = {0};
		glibtop_proc_uid _tmp19_;
		gint32 _tmp20_;
		glibtop_proc_time proc_time = {0};
		gint _tmp21_;
		glibtop_proc_time _tmp22_ = {0};
		glibtop_proc_time _tmp23_;
		guint64 _tmp24_;
		guint64 _tmp25_;
		glibtop_proc_time _tmp26_;
		guint64 _tmp27_;
		glibtop_proc_mem proc_mem = {0};
		gint _tmp28_;
		glibtop_proc_mem _tmp29_ = {0};
		glibtop_proc_mem _tmp30_;
		guint64 _tmp31_;
		glibtop_proc_mem _tmp32_;
		guint64 _tmp33_;
		GdkDisplay* _tmp34_;
		const gchar* _tmp41_;
#line 99 "../src/utils/Process.vala"
		_tmp7_ = stat_file;
#line 99 "../src/utils/Process.vala"
		_tmp8_ = g_file_read (_tmp7_, NULL, &_inner_error0_);
#line 99 "../src/utils/Process.vala"
		_tmp6_ = _tmp8_;
#line 99 "../src/utils/Process.vala"
		if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 318 "Process.c"
			goto __catch5_g_error;
		}
#line 99 "../src/utils/Process.vala"
		_tmp9_ = g_data_input_stream_new ((GInputStream*) _tmp6_);
#line 99 "../src/utils/Process.vala"
		dis = _tmp9_;
#line 100 "../src/utils/Process.vala"
		_tmp10_ = dis;
#line 100 "../src/utils/Process.vala"
		_tmp11_ = g_data_input_stream_read_line (_tmp10_, NULL, NULL, &_inner_error0_);
#line 100 "../src/utils/Process.vala"
		stat_contents = _tmp11_;
#line 100 "../src/utils/Process.vala"
		if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 100 "../src/utils/Process.vala"
			_g_object_unref0 (dis);
#line 100 "../src/utils/Process.vala"
			_g_object_unref0 (_tmp6_);
#line 337 "Process.c"
			goto __catch5_g_error;
		}
#line 102 "../src/utils/Process.vala"
		_tmp12_ = stat_contents;
#line 102 "../src/utils/Process.vala"
		if (_tmp12_ == NULL) {
#line 344 "Process.c"
			FILE* _tmp13_;
			GFile* _tmp14_;
			gchar* _tmp15_;
			gchar* _tmp16_;
#line 103 "../src/utils/Process.vala"
			_tmp13_ = stderr;
#line 103 "../src/utils/Process.vala"
			_tmp14_ = stat_file;
#line 103 "../src/utils/Process.vala"
			_tmp15_ = g_file_get_path (_tmp14_);
#line 103 "../src/utils/Process.vala"
			_tmp16_ = _tmp15_;
#line 103 "../src/utils/Process.vala"
			fprintf (_tmp13_, "Error reading stat file '%s': couldn't read_line ()\n", _tmp16_);
#line 103 "../src/utils/Process.vala"
			_g_free0 (_tmp16_);
#line 104 "../src/utils/Process.vala"
			result = FALSE;
#line 104 "../src/utils/Process.vala"
			_g_free0 (stat_contents);
#line 104 "../src/utils/Process.vala"
			_g_object_unref0 (dis);
#line 104 "../src/utils/Process.vala"
			_g_object_unref0 (_tmp6_);
#line 104 "../src/utils/Process.vala"
			_g_object_unref0 (stat_file);
#line 104 "../src/utils/Process.vala"
			return result;
#line 373 "Process.c"
		}
#line 109 "../src/utils/Process.vala"
		_tmp17_ = self->priv->_pid;
#line 109 "../src/utils/Process.vala"
		glibtop_get_proc_uid (&_tmp18_, _tmp17_);
#line 109 "../src/utils/Process.vala"
		uid = _tmp18_;
#line 110 "../src/utils/Process.vala"
		_tmp19_ = uid;
#line 110 "../src/utils/Process.vala"
		_tmp20_ = _tmp19_.pgrp;
#line 110 "../src/utils/Process.vala"
		optimizer_utils_process_set_pgrp (self, (gint) _tmp20_);
#line 114 "../src/utils/Process.vala"
		_tmp21_ = self->priv->_pid;
#line 114 "../src/utils/Process.vala"
		glibtop_get_proc_time (&_tmp22_, _tmp21_);
#line 114 "../src/utils/Process.vala"
		proc_time = _tmp22_;
#line 115 "../src/utils/Process.vala"
		_tmp23_ = proc_time;
#line 115 "../src/utils/Process.vala"
		_tmp24_ = _tmp23_.rtime;
#line 115 "../src/utils/Process.vala"
		_tmp25_ = self->priv->cpu_last_used;
#line 115 "../src/utils/Process.vala"
		optimizer_utils_process_set_cpu_usage (self, ((gdouble) (_tmp24_ - _tmp25_)) / (cpu_total - cpu_last_total));
#line 116 "../src/utils/Process.vala"
		_tmp26_ = proc_time;
#line 116 "../src/utils/Process.vala"
		_tmp27_ = _tmp26_.rtime;
#line 116 "../src/utils/Process.vala"
		self->priv->cpu_last_used = _tmp27_;
#line 120 "../src/utils/Process.vala"
		_tmp28_ = self->priv->_pid;
#line 120 "../src/utils/Process.vala"
		glibtop_get_proc_mem (&_tmp29_, _tmp28_);
#line 120 "../src/utils/Process.vala"
		proc_mem = _tmp29_;
#line 121 "../src/utils/Process.vala"
		_tmp30_ = proc_mem;
#line 121 "../src/utils/Process.vala"
		_tmp31_ = _tmp30_.resident;
#line 121 "../src/utils/Process.vala"
		_tmp32_ = proc_mem;
#line 121 "../src/utils/Process.vala"
		_tmp33_ = _tmp32_.share;
#line 121 "../src/utils/Process.vala"
		optimizer_utils_process_set_mem_usage (self, _tmp31_ - _tmp33_);
#line 123 "../src/utils/Process.vala"
		_tmp34_ = gdk_display_get_default ();
#line 123 "../src/utils/Process.vala"
		if (G_TYPE_CHECK_INSTANCE_TYPE (_tmp34_, gdk_x11_display_get_type ())) {
#line 427 "Process.c"
			WnckResourceUsage resu = {0};
			GdkDisplay* _tmp35_;
			gint _tmp36_;
			WnckResourceUsage _tmp37_ = {0};
			guint64 _tmp38_;
			WnckResourceUsage _tmp39_;
			gulong _tmp40_;
#line 124 "../src/utils/Process.vala"
			_tmp35_ = gdk_display_get_default ();
#line 124 "../src/utils/Process.vala"
			_tmp36_ = self->priv->_pid;
#line 124 "../src/utils/Process.vala"
			wnck_pid_read_resource_usage (_tmp35_, (gulong) _tmp36_, &_tmp37_);
#line 124 "../src/utils/Process.vala"
			resu = _tmp37_;
#line 125 "../src/utils/Process.vala"
			_tmp38_ = self->priv->_mem_usage;
#line 125 "../src/utils/Process.vala"
			_tmp39_ = resu;
#line 125 "../src/utils/Process.vala"
			_tmp40_ = _tmp39_.total_bytes_estimate;
#line 125 "../src/utils/Process.vala"
			optimizer_utils_process_set_mem_usage (self, _tmp38_ + _tmp40_);
#line 451 "Process.c"
		}
#line 129 "../src/utils/Process.vala"
		_tmp41_ = getlogin ();
#line 129 "../src/utils/Process.vala"
		optimizer_utils_process_set_user (self, _tmp41_);
#line 97 "../src/utils/Process.vala"
		_g_free0 (stat_contents);
#line 97 "../src/utils/Process.vala"
		_g_object_unref0 (dis);
#line 97 "../src/utils/Process.vala"
		_g_object_unref0 (_tmp6_);
#line 463 "Process.c"
	}
	goto __finally5;
	__catch5_g_error:
	{
		GError* e = NULL;
		GError* _tmp42_;
		const gchar* _tmp43_;
#line 97 "../src/utils/Process.vala"
		e = _inner_error0_;
#line 97 "../src/utils/Process.vala"
		_inner_error0_ = NULL;
#line 131 "../src/utils/Process.vala"
		_tmp42_ = e;
#line 131 "../src/utils/Process.vala"
		_tmp43_ = _tmp42_->message;
#line 131 "../src/utils/Process.vala"
		g_warning ("Process.vala:131: Can't read process stat: '%s'", _tmp43_);
#line 132 "../src/utils/Process.vala"
		result = FALSE;
#line 132 "../src/utils/Process.vala"
		_g_error_free0 (e);
#line 132 "../src/utils/Process.vala"
		_g_object_unref0 (stat_file);
#line 132 "../src/utils/Process.vala"
		return result;
#line 489 "Process.c"
	}
	__finally5:
#line 97 "../src/utils/Process.vala"
	if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 494 "Process.c"
		gboolean _tmp44_ = FALSE;
#line 97 "../src/utils/Process.vala"
		_g_object_unref0 (stat_file);
#line 97 "../src/utils/Process.vala"
		g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
#line 97 "../src/utils/Process.vala"
		g_clear_error (&_inner_error0_);
#line 97 "../src/utils/Process.vala"
		return _tmp44_;
#line 504 "Process.c"
	}
#line 135 "../src/utils/Process.vala"
	result = TRUE;
#line 135 "../src/utils/Process.vala"
	_g_object_unref0 (stat_file);
#line 135 "../src/utils/Process.vala"
	return result;
#line 512 "Process.c"
}


/**
         * Reads the /proc/%pid%/cmdline file and updates from the information contained therein.
         */
static gboolean
optimizer_utils_process_read_cmdline (OptimizerUtilsProcess* self)
{
	gboolean result = FALSE;
	GFile* cmdline_file = NULL;
	gint _tmp0_;
	gchar* _tmp1_;
	gchar* _tmp2_;
	GFile* _tmp3_;
	GFile* _tmp4_;
	GFile* _tmp5_;
	GError* _inner_error0_ = NULL;
#line 141 "../src/utils/Process.vala"
	g_return_val_if_fail (self != NULL, FALSE);
#line 143 "../src/utils/Process.vala"
	_tmp0_ = self->priv->_pid;
#line 143 "../src/utils/Process.vala"
	_tmp1_ = g_strdup_printf ("/proc/%d/cmdline", _tmp0_);
#line 143 "../src/utils/Process.vala"
	_tmp2_ = _tmp1_;
#line 143 "../src/utils/Process.vala"
	_tmp3_ = g_file_new_for_path (_tmp2_);
#line 143 "../src/utils/Process.vala"
	_tmp4_ = _tmp3_;
#line 143 "../src/utils/Process.vala"
	_g_free0 (_tmp2_);
#line 143 "../src/utils/Process.vala"
	cmdline_file = _tmp4_;
#line 146 "../src/utils/Process.vala"
	_tmp5_ = cmdline_file;
#line 146 "../src/utils/Process.vala"
	if (!g_file_query_exists (_tmp5_, NULL)) {
#line 551 "Process.c"
		GFile* _tmp6_;
		gchar* _tmp7_;
		gchar* _tmp8_;
#line 147 "../src/utils/Process.vala"
		_tmp6_ = cmdline_file;
#line 147 "../src/utils/Process.vala"
		_tmp7_ = g_file_get_path (_tmp6_);
#line 147 "../src/utils/Process.vala"
		_tmp8_ = _tmp7_;
#line 147 "../src/utils/Process.vala"
		g_warning ("Process.vala:147: File '%s' doesn't exist.\n", _tmp8_);
#line 147 "../src/utils/Process.vala"
		_g_free0 (_tmp8_);
#line 148 "../src/utils/Process.vala"
		result = FALSE;
#line 148 "../src/utils/Process.vala"
		_g_object_unref0 (cmdline_file);
#line 148 "../src/utils/Process.vala"
		return result;
#line 571 "Process.c"
	}
	{
		GFileInputStream* _tmp9_ = NULL;
		GFile* _tmp10_;
		GFileInputStream* _tmp11_;
		GDataInputStream* dis = NULL;
		GDataInputStream* _tmp12_;
		guint8* cmdline_contents_array = NULL;
		guint8* _tmp13_;
		gint cmdline_contents_array_length1;
		gint _cmdline_contents_array_size_;
		gssize size = 0L;
		GDataInputStream* _tmp14_;
		guint8* _tmp15_;
		gint _tmp15__length1;
		gssize _tmp16_;
		guint8* _tmp30_;
		gint _tmp30__length1;
		gssize _tmp31_;
		gchar* cmdline_contents = NULL;
		guint8* _tmp32_;
		gint _tmp32__length1;
		gchar* _tmp33_;
		glibtop_proc_state proc_state = {0};
		gint _tmp34_;
		glibtop_proc_state _tmp35_ = {0};
		const gchar* _tmp36_;
#line 152 "../src/utils/Process.vala"
		_tmp10_ = cmdline_file;
#line 152 "../src/utils/Process.vala"
		_tmp11_ = g_file_read (_tmp10_, NULL, &_inner_error0_);
#line 152 "../src/utils/Process.vala"
		_tmp9_ = _tmp11_;
#line 152 "../src/utils/Process.vala"
		if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 607 "Process.c"
			goto __catch6_g_error;
		}
#line 152 "../src/utils/Process.vala"
		_tmp12_ = g_data_input_stream_new ((GInputStream*) _tmp9_);
#line 152 "../src/utils/Process.vala"
		dis = _tmp12_;
#line 153 "../src/utils/Process.vala"
		_tmp13_ = g_new0 (guint8, 4097);
#line 153 "../src/utils/Process.vala"
		cmdline_contents_array = _tmp13_;
#line 153 "../src/utils/Process.vala"
		cmdline_contents_array_length1 = 4097;
#line 153 "../src/utils/Process.vala"
		_cmdline_contents_array_size_ = cmdline_contents_array_length1;
#line 154 "../src/utils/Process.vala"
		_tmp14_ = dis;
#line 154 "../src/utils/Process.vala"
		_tmp15_ = cmdline_contents_array;
#line 154 "../src/utils/Process.vala"
		_tmp15__length1 = cmdline_contents_array_length1;
#line 154 "../src/utils/Process.vala"
		size = g_input_stream_read ((GInputStream*) _tmp14_, _tmp15_, (gsize) _tmp15__length1, NULL, &_inner_error0_);
#line 154 "../src/utils/Process.vala"
		if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 154 "../src/utils/Process.vala"
			cmdline_contents_array = (g_free (cmdline_contents_array), NULL);
#line 154 "../src/utils/Process.vala"
			_g_object_unref0 (dis);
#line 154 "../src/utils/Process.vala"
			_g_object_unref0 (_tmp9_);
#line 638 "Process.c"
			goto __catch6_g_error;
		}
#line 156 "../src/utils/Process.vala"
		_tmp16_ = size;
#line 156 "../src/utils/Process.vala"
		if (_tmp16_ <= ((gssize) 0)) {
#line 158 "../src/utils/Process.vala"
			result = TRUE;
#line 158 "../src/utils/Process.vala"
			cmdline_contents_array = (g_free (cmdline_contents_array), NULL);
#line 158 "../src/utils/Process.vala"
			_g_object_unref0 (dis);
#line 158 "../src/utils/Process.vala"
			_g_object_unref0 (_tmp9_);
#line 158 "../src/utils/Process.vala"
			_g_object_unref0 (cmdline_file);
#line 158 "../src/utils/Process.vala"
			return result;
#line 657 "Process.c"
		}
		{
			gint pos = 0;
#line 163 "../src/utils/Process.vala"
			pos = 0;
#line 663 "Process.c"
			{
				gboolean _tmp17_ = FALSE;
#line 163 "../src/utils/Process.vala"
				_tmp17_ = TRUE;
#line 163 "../src/utils/Process.vala"
				while (TRUE) {
#line 670 "Process.c"
					gint _tmp19_;
					gssize _tmp20_;
					gboolean _tmp21_ = FALSE;
					guint8* _tmp22_;
					gint _tmp22__length1;
					gint _tmp23_;
					guint8 _tmp24_;
#line 163 "../src/utils/Process.vala"
					if (!_tmp17_) {
#line 680 "Process.c"
						gint _tmp18_;
#line 163 "../src/utils/Process.vala"
						_tmp18_ = pos;
#line 163 "../src/utils/Process.vala"
						pos = _tmp18_ + 1;
#line 686 "Process.c"
					}
#line 163 "../src/utils/Process.vala"
					_tmp17_ = FALSE;
#line 163 "../src/utils/Process.vala"
					_tmp19_ = pos;
#line 163 "../src/utils/Process.vala"
					_tmp20_ = size;
#line 163 "../src/utils/Process.vala"
					if (!(((gssize) _tmp19_) < _tmp20_)) {
#line 163 "../src/utils/Process.vala"
						break;
#line 698 "Process.c"
					}
#line 164 "../src/utils/Process.vala"
					_tmp22_ = cmdline_contents_array;
#line 164 "../src/utils/Process.vala"
					_tmp22__length1 = cmdline_contents_array_length1;
#line 164 "../src/utils/Process.vala"
					_tmp23_ = pos;
#line 164 "../src/utils/Process.vala"
					_tmp24_ = _tmp22_[_tmp23_];
#line 164 "../src/utils/Process.vala"
					if (_tmp24_ == ((guint8) '\0')) {
#line 164 "../src/utils/Process.vala"
						_tmp21_ = TRUE;
#line 712 "Process.c"
					} else {
						guint8* _tmp25_;
						gint _tmp25__length1;
						gint _tmp26_;
						guint8 _tmp27_;
#line 164 "../src/utils/Process.vala"
						_tmp25_ = cmdline_contents_array;
#line 164 "../src/utils/Process.vala"
						_tmp25__length1 = cmdline_contents_array_length1;
#line 164 "../src/utils/Process.vala"
						_tmp26_ = pos;
#line 164 "../src/utils/Process.vala"
						_tmp27_ = _tmp25_[_tmp26_];
#line 164 "../src/utils/Process.vala"
						_tmp21_ = _tmp27_ == ((guint8) '\n');
#line 728 "Process.c"
					}
#line 164 "../src/utils/Process.vala"
					if (_tmp21_) {
#line 732 "Process.c"
						guint8* _tmp28_;
						gint _tmp28__length1;
						gint _tmp29_;
#line 165 "../src/utils/Process.vala"
						_tmp28_ = cmdline_contents_array;
#line 165 "../src/utils/Process.vala"
						_tmp28__length1 = cmdline_contents_array_length1;
#line 165 "../src/utils/Process.vala"
						_tmp29_ = pos;
#line 165 "../src/utils/Process.vala"
						_tmp28_[_tmp29_] = (guint8) ' ';
#line 744 "Process.c"
					}
				}
			}
		}
#line 168 "../src/utils/Process.vala"
		_tmp30_ = cmdline_contents_array;
#line 168 "../src/utils/Process.vala"
		_tmp30__length1 = cmdline_contents_array_length1;
#line 168 "../src/utils/Process.vala"
		_tmp31_ = size;
#line 168 "../src/utils/Process.vala"
		_tmp30_[_tmp31_] = (guint8) '\0';
#line 169 "../src/utils/Process.vala"
		_tmp32_ = cmdline_contents_array;
#line 169 "../src/utils/Process.vala"
		_tmp32__length1 = cmdline_contents_array_length1;
#line 169 "../src/utils/Process.vala"
		_tmp33_ = g_strdup ((const gchar*) _tmp32_);
#line 169 "../src/utils/Process.vala"
		cmdline_contents = _tmp33_;
#line 173 "../src/utils/Process.vala"
		_tmp34_ = self->priv->_pid;
#line 173 "../src/utils/Process.vala"
		glibtop_get_proc_state (&_tmp35_, _tmp34_);
#line 173 "../src/utils/Process.vala"
		proc_state = _tmp35_;
#line 175 "../src/utils/Process.vala"
		_tmp36_ = cmdline_contents;
#line 175 "../src/utils/Process.vala"
		optimizer_utils_process_set_command (self, _tmp36_);
#line 150 "../src/utils/Process.vala"
		_g_free0 (cmdline_contents);
#line 150 "../src/utils/Process.vala"
		cmdline_contents_array = (g_free (cmdline_contents_array), NULL);
#line 150 "../src/utils/Process.vala"
		_g_object_unref0 (dis);
#line 150 "../src/utils/Process.vala"
		_g_object_unref0 (_tmp9_);
#line 783 "Process.c"
	}
	goto __finally6;
	__catch6_g_error:
	{
		GError* e = NULL;
		FILE* _tmp37_;
		GFile* _tmp38_;
		gchar* _tmp39_;
		gchar* _tmp40_;
		GError* _tmp41_;
		const gchar* _tmp42_;
#line 150 "../src/utils/Process.vala"
		e = _inner_error0_;
#line 150 "../src/utils/Process.vala"
		_inner_error0_ = NULL;
#line 178 "../src/utils/Process.vala"
		_tmp37_ = stderr;
#line 178 "../src/utils/Process.vala"
		_tmp38_ = cmdline_file;
#line 178 "../src/utils/Process.vala"
		_tmp39_ = g_file_get_path (_tmp38_);
#line 178 "../src/utils/Process.vala"
		_tmp40_ = _tmp39_;
#line 178 "../src/utils/Process.vala"
		_tmp41_ = e;
#line 178 "../src/utils/Process.vala"
		_tmp42_ = _tmp41_->message;
#line 178 "../src/utils/Process.vala"
		fprintf (_tmp37_, "Error reading cmdline file '%s': %s\n", _tmp40_, _tmp42_);
#line 178 "../src/utils/Process.vala"
		_g_free0 (_tmp40_);
#line 179 "../src/utils/Process.vala"
		result = FALSE;
#line 179 "../src/utils/Process.vala"
		_g_error_free0 (e);
#line 179 "../src/utils/Process.vala"
		_g_object_unref0 (cmdline_file);
#line 179 "../src/utils/Process.vala"
		return result;
#line 823 "Process.c"
	}
	__finally6:
#line 150 "../src/utils/Process.vala"
	if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 828 "Process.c"
		gboolean _tmp43_ = FALSE;
#line 150 "../src/utils/Process.vala"
		_g_object_unref0 (cmdline_file);
#line 150 "../src/utils/Process.vala"
		g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
#line 150 "../src/utils/Process.vala"
		g_clear_error (&_inner_error0_);
#line 150 "../src/utils/Process.vala"
		return _tmp43_;
#line 838 "Process.c"
	}
#line 182 "../src/utils/Process.vala"
	result = TRUE;
#line 182 "../src/utils/Process.vala"
	_g_object_unref0 (cmdline_file);
#line 182 "../src/utils/Process.vala"
	return result;
#line 846 "Process.c"
}


gboolean
optimizer_utils_process_get_exists (OptimizerUtilsProcess* self)
{
	gboolean result;
	gboolean _tmp0_;
#line 32 "../src/utils/Process.vala"
	g_return_val_if_fail (self != NULL, FALSE);
#line 32 "../src/utils/Process.vala"
	_tmp0_ = self->priv->_exists;
#line 32 "../src/utils/Process.vala"
	result = _tmp0_;
#line 32 "../src/utils/Process.vala"
	return result;
#line 863 "Process.c"
}


static void
optimizer_utils_process_set_exists (OptimizerUtilsProcess* self,
                                    gboolean value)
{
#line 32 "../src/utils/Process.vala"
	g_return_if_fail (self != NULL);
#line 32 "../src/utils/Process.vala"
	self->priv->_exists = value;
#line 875 "Process.c"
}


gint
optimizer_utils_process_get_pid (OptimizerUtilsProcess* self)
{
	gint result;
	gint _tmp0_;
#line 35 "../src/utils/Process.vala"
	g_return_val_if_fail (self != NULL, 0);
#line 35 "../src/utils/Process.vala"
	_tmp0_ = self->priv->_pid;
#line 35 "../src/utils/Process.vala"
	result = _tmp0_;
#line 35 "../src/utils/Process.vala"
	return result;
#line 892 "Process.c"
}


static void
optimizer_utils_process_set_pid (OptimizerUtilsProcess* self,
                                 gint value)
{
#line 35 "../src/utils/Process.vala"
	g_return_if_fail (self != NULL);
#line 35 "../src/utils/Process.vala"
	self->priv->_pid = value;
#line 904 "Process.c"
}


gint
optimizer_utils_process_get_pgrp (OptimizerUtilsProcess* self)
{
	gint result;
	gint _tmp0_;
#line 38 "../src/utils/Process.vala"
	g_return_val_if_fail (self != NULL, 0);
#line 38 "../src/utils/Process.vala"
	_tmp0_ = self->priv->_pgrp;
#line 38 "../src/utils/Process.vala"
	result = _tmp0_;
#line 38 "../src/utils/Process.vala"
	return result;
#line 921 "Process.c"
}


static void
optimizer_utils_process_set_pgrp (OptimizerUtilsProcess* self,
                                  gint value)
{
#line 38 "../src/utils/Process.vala"
	g_return_if_fail (self != NULL);
#line 38 "../src/utils/Process.vala"
	self->priv->_pgrp = value;
#line 933 "Process.c"
}


const gchar*
optimizer_utils_process_get_command (OptimizerUtilsProcess* self)
{
	const gchar* result;
	const gchar* _tmp0_;
#line 41 "../src/utils/Process.vala"
	g_return_val_if_fail (self != NULL, NULL);
#line 41 "../src/utils/Process.vala"
	_tmp0_ = self->priv->_command;
#line 41 "../src/utils/Process.vala"
	result = _tmp0_;
#line 41 "../src/utils/Process.vala"
	return result;
#line 950 "Process.c"
}


static void
optimizer_utils_process_set_command (OptimizerUtilsProcess* self,
                                     const gchar* value)
{
	gchar* _tmp0_;
#line 41 "../src/utils/Process.vala"
	g_return_if_fail (self != NULL);
#line 41 "../src/utils/Process.vala"
	_tmp0_ = g_strdup (value);
#line 41 "../src/utils/Process.vala"
	_g_free0 (self->priv->_command);
#line 41 "../src/utils/Process.vala"
	self->priv->_command = _tmp0_;
#line 967 "Process.c"
}


const gchar*
optimizer_utils_process_get_user (OptimizerUtilsProcess* self)
{
	const gchar* result;
	const gchar* _tmp0_;
#line 44 "../src/utils/Process.vala"
	g_return_val_if_fail (self != NULL, NULL);
#line 44 "../src/utils/Process.vala"
	_tmp0_ = self->priv->_user;
#line 44 "../src/utils/Process.vala"
	result = _tmp0_;
#line 44 "../src/utils/Process.vala"
	return result;
#line 984 "Process.c"
}


static void
optimizer_utils_process_set_user (OptimizerUtilsProcess* self,
                                  const gchar* value)
{
	gchar* _tmp0_;
#line 44 "../src/utils/Process.vala"
	g_return_if_fail (self != NULL);
#line 44 "../src/utils/Process.vala"
	_tmp0_ = g_strdup (value);
#line 44 "../src/utils/Process.vala"
	_g_free0 (self->priv->_user);
#line 44 "../src/utils/Process.vala"
	self->priv->_user = _tmp0_;
#line 1001 "Process.c"
}


gdouble
optimizer_utils_process_get_cpu_usage (OptimizerUtilsProcess* self)
{
	gdouble result;
	gdouble _tmp0_;
#line 51 "../src/utils/Process.vala"
	g_return_val_if_fail (self != NULL, 0.0);
#line 51 "../src/utils/Process.vala"
	_tmp0_ = self->priv->_cpu_usage;
#line 51 "../src/utils/Process.vala"
	result = _tmp0_;
#line 51 "../src/utils/Process.vala"
	return result;
#line 1018 "Process.c"
}


static void
optimizer_utils_process_set_cpu_usage (OptimizerUtilsProcess* self,
                                       gdouble value)
{
#line 51 "../src/utils/Process.vala"
	g_return_if_fail (self != NULL);
#line 51 "../src/utils/Process.vala"
	self->priv->_cpu_usage = value;
#line 1030 "Process.c"
}


guint64
optimizer_utils_process_get_mem_usage (OptimizerUtilsProcess* self)
{
	guint64 result;
	guint64 _tmp0_;
#line 57 "../src/utils/Process.vala"
	g_return_val_if_fail (self != NULL, 0ULL);
#line 57 "../src/utils/Process.vala"
	_tmp0_ = self->priv->_mem_usage;
#line 57 "../src/utils/Process.vala"
	result = _tmp0_;
#line 57 "../src/utils/Process.vala"
	return result;
#line 1047 "Process.c"
}


static void
optimizer_utils_process_set_mem_usage (OptimizerUtilsProcess* self,
                                       guint64 value)
{
#line 57 "../src/utils/Process.vala"
	g_return_if_fail (self != NULL);
#line 57 "../src/utils/Process.vala"
	self->priv->_mem_usage = value;
#line 1059 "Process.c"
}


static void
optimizer_utils_value_process_init (GValue* value)
{
#line 30 "../src/utils/Process.vala"
	value->data[0].v_pointer = NULL;
#line 1068 "Process.c"
}


static void
optimizer_utils_value_process_free_value (GValue* value)
{
#line 30 "../src/utils/Process.vala"
	if (value->data[0].v_pointer) {
#line 30 "../src/utils/Process.vala"
		optimizer_utils_process_unref (value->data[0].v_pointer);
#line 1079 "Process.c"
	}
}


static void
optimizer_utils_value_process_copy_value (const GValue* src_value,
                                          GValue* dest_value)
{
#line 30 "../src/utils/Process.vala"
	if (src_value->data[0].v_pointer) {
#line 30 "../src/utils/Process.vala"
		dest_value->data[0].v_pointer = optimizer_utils_process_ref (src_value->data[0].v_pointer);
#line 1092 "Process.c"
	} else {
#line 30 "../src/utils/Process.vala"
		dest_value->data[0].v_pointer = NULL;
#line 1096 "Process.c"
	}
}


static gpointer
optimizer_utils_value_process_peek_pointer (const GValue* value)
{
#line 30 "../src/utils/Process.vala"
	return value->data[0].v_pointer;
#line 1106 "Process.c"
}


static gchar*
optimizer_utils_value_process_collect_value (GValue* value,
                                             guint n_collect_values,
                                             GTypeCValue* collect_values,
                                             guint collect_flags)
{
#line 30 "../src/utils/Process.vala"
	if (collect_values[0].v_pointer) {
#line 1118 "Process.c"
		OptimizerUtilsProcess * object;
		object = collect_values[0].v_pointer;
#line 30 "../src/utils/Process.vala"
		if (object->parent_instance.g_class == NULL) {
#line 30 "../src/utils/Process.vala"
			return g_strconcat ("invalid unclassed object pointer for value type `", G_VALUE_TYPE_NAME (value), "'", NULL);
#line 1125 "Process.c"
		} else if (!g_value_type_compatible (G_TYPE_FROM_INSTANCE (object), G_VALUE_TYPE (value))) {
#line 30 "../src/utils/Process.vala"
			return g_strconcat ("invalid object type `", g_type_name (G_TYPE_FROM_INSTANCE (object)), "' for value type `", G_VALUE_TYPE_NAME (value), "'", NULL);
#line 1129 "Process.c"
		}
#line 30 "../src/utils/Process.vala"
		value->data[0].v_pointer = optimizer_utils_process_ref (object);
#line 1133 "Process.c"
	} else {
#line 30 "../src/utils/Process.vala"
		value->data[0].v_pointer = NULL;
#line 1137 "Process.c"
	}
#line 30 "../src/utils/Process.vala"
	return NULL;
#line 1141 "Process.c"
}


static gchar*
optimizer_utils_value_process_lcopy_value (const GValue* value,
                                           guint n_collect_values,
                                           GTypeCValue* collect_values,
                                           guint collect_flags)
{
	OptimizerUtilsProcess ** object_p;
	object_p = collect_values[0].v_pointer;
#line 30 "../src/utils/Process.vala"
	if (!object_p) {
#line 30 "../src/utils/Process.vala"
		return g_strdup_printf ("value location for `%s' passed as NULL", G_VALUE_TYPE_NAME (value));
#line 1157 "Process.c"
	}
#line 30 "../src/utils/Process.vala"
	if (!value->data[0].v_pointer) {
#line 30 "../src/utils/Process.vala"
		*object_p = NULL;
#line 1163 "Process.c"
	} else if (collect_flags & G_VALUE_NOCOPY_CONTENTS) {
#line 30 "../src/utils/Process.vala"
		*object_p = value->data[0].v_pointer;
#line 1167 "Process.c"
	} else {
#line 30 "../src/utils/Process.vala"
		*object_p = optimizer_utils_process_ref (value->data[0].v_pointer);
#line 1171 "Process.c"
	}
#line 30 "../src/utils/Process.vala"
	return NULL;
#line 1175 "Process.c"
}


GParamSpec*
optimizer_utils_param_spec_process (const gchar* name,
                                    const gchar* nick,
                                    const gchar* blurb,
                                    GType object_type,
                                    GParamFlags flags)
{
	OptimizerUtilsParamSpecProcess* spec;
#line 30 "../src/utils/Process.vala"
	g_return_val_if_fail (g_type_is_a (object_type, OPTIMIZER_UTILS_TYPE_PROCESS), NULL);
#line 30 "../src/utils/Process.vala"
	spec = g_param_spec_internal (G_TYPE_PARAM_OBJECT, name, nick, blurb, flags);
#line 30 "../src/utils/Process.vala"
	G_PARAM_SPEC (spec)->value_type = object_type;
#line 30 "../src/utils/Process.vala"
	return G_PARAM_SPEC (spec);
#line 1195 "Process.c"
}


gpointer
optimizer_utils_value_get_process (const GValue* value)
{
#line 30 "../src/utils/Process.vala"
	g_return_val_if_fail (G_TYPE_CHECK_VALUE_TYPE (value, OPTIMIZER_UTILS_TYPE_PROCESS), NULL);
#line 30 "../src/utils/Process.vala"
	return value->data[0].v_pointer;
#line 1206 "Process.c"
}


void
optimizer_utils_value_set_process (GValue* value,
                                   gpointer v_object)
{
	OptimizerUtilsProcess * old;
#line 30 "../src/utils/Process.vala"
	g_return_if_fail (G_TYPE_CHECK_VALUE_TYPE (value, OPTIMIZER_UTILS_TYPE_PROCESS));
#line 30 "../src/utils/Process.vala"
	old = value->data[0].v_pointer;
#line 30 "../src/utils/Process.vala"
	if (v_object) {
#line 30 "../src/utils/Process.vala"
		g_return_if_fail (G_TYPE_CHECK_INSTANCE_TYPE (v_object, OPTIMIZER_UTILS_TYPE_PROCESS));
#line 30 "../src/utils/Process.vala"
		g_return_if_fail (g_value_type_compatible (G_TYPE_FROM_INSTANCE (v_object), G_VALUE_TYPE (value)));
#line 30 "../src/utils/Process.vala"
		value->data[0].v_pointer = v_object;
#line 30 "../src/utils/Process.vala"
		optimizer_utils_process_ref (value->data[0].v_pointer);
#line 1229 "Process.c"
	} else {
#line 30 "../src/utils/Process.vala"
		value->data[0].v_pointer = NULL;
#line 1233 "Process.c"
	}
#line 30 "../src/utils/Process.vala"
	if (old) {
#line 30 "../src/utils/Process.vala"
		optimizer_utils_process_unref (old);
#line 1239 "Process.c"
	}
}


void
optimizer_utils_value_take_process (GValue* value,
                                    gpointer v_object)
{
	OptimizerUtilsProcess * old;
#line 30 "../src/utils/Process.vala"
	g_return_if_fail (G_TYPE_CHECK_VALUE_TYPE (value, OPTIMIZER_UTILS_TYPE_PROCESS));
#line 30 "../src/utils/Process.vala"
	old = value->data[0].v_pointer;
#line 30 "../src/utils/Process.vala"
	if (v_object) {
#line 30 "../src/utils/Process.vala"
		g_return_if_fail (G_TYPE_CHECK_INSTANCE_TYPE (v_object, OPTIMIZER_UTILS_TYPE_PROCESS));
#line 30 "../src/utils/Process.vala"
		g_return_if_fail (g_value_type_compatible (G_TYPE_FROM_INSTANCE (v_object), G_VALUE_TYPE (value)));
#line 30 "../src/utils/Process.vala"
		value->data[0].v_pointer = v_object;
#line 1261 "Process.c"
	} else {
#line 30 "../src/utils/Process.vala"
		value->data[0].v_pointer = NULL;
#line 1265 "Process.c"
	}
#line 30 "../src/utils/Process.vala"
	if (old) {
#line 30 "../src/utils/Process.vala"
		optimizer_utils_process_unref (old);
#line 1271 "Process.c"
	}
}


static void
optimizer_utils_process_class_init (OptimizerUtilsProcessClass * klass)
{
#line 30 "../src/utils/Process.vala"
	optimizer_utils_process_parent_class = g_type_class_peek_parent (klass);
#line 30 "../src/utils/Process.vala"
	((OptimizerUtilsProcessClass *) klass)->finalize = optimizer_utils_process_finalize;
#line 30 "../src/utils/Process.vala"
	g_type_class_adjust_private_offset (klass, &OptimizerUtilsProcess_private_offset);
#line 1285 "Process.c"
}


static void
optimizer_utils_process_instance_init (OptimizerUtilsProcess * self)
{
#line 30 "../src/utils/Process.vala"
	self->priv = optimizer_utils_process_get_instance_private (self);
#line 30 "../src/utils/Process.vala"
	self->ref_count = 1;
#line 1296 "Process.c"
}


static void
optimizer_utils_process_finalize (OptimizerUtilsProcess * obj)
{
	OptimizerUtilsProcess * self;
#line 30 "../src/utils/Process.vala"
	self = G_TYPE_CHECK_INSTANCE_CAST (obj, OPTIMIZER_UTILS_TYPE_PROCESS, OptimizerUtilsProcess);
#line 30 "../src/utils/Process.vala"
	g_signal_handlers_destroy (self);
#line 41 "../src/utils/Process.vala"
	_g_free0 (self->priv->_command);
#line 44 "../src/utils/Process.vala"
	_g_free0 (self->priv->_user);
#line 1312 "Process.c"
}


/**
     * The {@code Process} class represents one process
     *
     * @since 1.0.0
     */
GType
optimizer_utils_process_get_type (void)
{
	static volatile gsize optimizer_utils_process_type_id__volatile = 0;
	if (g_once_init_enter (&optimizer_utils_process_type_id__volatile)) {
		static const GTypeValueTable g_define_type_value_table = { optimizer_utils_value_process_init, optimizer_utils_value_process_free_value, optimizer_utils_value_process_copy_value, optimizer_utils_value_process_peek_pointer, "p", optimizer_utils_value_process_collect_value, "p", optimizer_utils_value_process_lcopy_value };
		static const GTypeInfo g_define_type_info = { sizeof (OptimizerUtilsProcessClass), (GBaseInitFunc) NULL, (GBaseFinalizeFunc) NULL, (GClassInitFunc) optimizer_utils_process_class_init, (GClassFinalizeFunc) NULL, NULL, sizeof (OptimizerUtilsProcess), 0, (GInstanceInitFunc) optimizer_utils_process_instance_init, &g_define_type_value_table };
		static const GTypeFundamentalInfo g_define_type_fundamental_info = { (G_TYPE_FLAG_CLASSED | G_TYPE_FLAG_INSTANTIATABLE | G_TYPE_FLAG_DERIVABLE | G_TYPE_FLAG_DEEP_DERIVABLE) };
		GType optimizer_utils_process_type_id;
		optimizer_utils_process_type_id = g_type_register_fundamental (g_type_fundamental_next (), "OptimizerUtilsProcess", &g_define_type_info, &g_define_type_fundamental_info, 0);
		OptimizerUtilsProcess_private_offset = g_type_add_instance_private (optimizer_utils_process_type_id, sizeof (OptimizerUtilsProcessPrivate));
		g_once_init_leave (&optimizer_utils_process_type_id__volatile, optimizer_utils_process_type_id);
	}
	return optimizer_utils_process_type_id__volatile;
}


gpointer
optimizer_utils_process_ref (gpointer instance)
{
	OptimizerUtilsProcess * self;
	self = instance;
#line 30 "../src/utils/Process.vala"
	g_atomic_int_inc (&self->ref_count);
#line 30 "../src/utils/Process.vala"
	return instance;
#line 1347 "Process.c"
}


void
optimizer_utils_process_unref (gpointer instance)
{
	OptimizerUtilsProcess * self;
	self = instance;
#line 30 "../src/utils/Process.vala"
	if (g_atomic_int_dec_and_test (&self->ref_count)) {
#line 30 "../src/utils/Process.vala"
		OPTIMIZER_UTILS_PROCESS_GET_CLASS (self)->finalize (self);
#line 30 "../src/utils/Process.vala"
		g_type_free_instance ((GTypeInstance *) self);
#line 1362 "Process.c"
	}
}



